      SUBROUTINE CREV_CELLS1(ROWS,COLS,CMARK,CREV_DEP,STRESS,ICE)

      IMPLICIT NONE

      INTEGER :: ROWS,COLS,CMARK(COLS,ROWS),I,J

      DOUBLE PRECISION :: CREV_DEP(COLS,ROWS),STRESS(COLS,ROWS),
     &ICE(COLS,ROWS)

      ! THOSE DEM CELLS, WHOSE VON MISES STRESS IS MORE THAN 280 kPa ARE
      ! CLASSIFIED AS CREVASSED CELLS AND THE CREVASSE DEPTH IS
      ! INITIALISED TO 0.1 M

      ! ROWS,COLS: ROWS AND COLUMNS OF THE STUDY AREA. REMAINS
      ! UNMODIFIED IN THIS SUBROUTINE

      ! CMARK: SHOWS 1 FOR CREVASSED CELL AND 0 FOR NON CREVASSED CELL.
      ! UPDATED EVERY TIMESTEP IN THE CREV_CELLS1.F SUBROUTINE. GETS
      ! MODIFIED IN THIS SUBROUTINE

      ! CREV_DEP: CONTAINS CREVASSE DEPTH FOR EVERY GRID CELL.
      ! GETS MODIFIED IN THIS SUBROUTINE

      ! ICE: CONTAINS ICE THICKNESS (IN METERS) FOR EVERY GRID CELL.
      ! REMAINS UNMODIFIED IN THIS SUBROUTINE

      ! STRESS: CONTAINS STRESS (IN kPa) FOR EVERY GRID CELL. REMAINS
      ! UNMODIFIED IN THIS SUBROUTINE
       
      DO 100 I=1,COLS
      DO 200 J=1,ROWS
      IF ((STRESS(I,J).GE.280).AND.(ICE(I,J).GT.0)) THEN
              CMARK(I,J)=1
              IF ((CMARK(I,J).EQ.1).AND.(CREV_DEP(I,J).EQ.0)) THEN
                      CREV_DEP(I,J)=0.1
              END IF
      END IF
200   CONTINUE
100   CONTINUE

      RETURN

      END SUBROUTINE CREV_CELLS1
