        SUBROUTINE REINIT1(ROWS,COLS,CREV_DEP,WAT_DEP,ICE,RUNOFF,C_MARK)

        ! THIS SUBROUTINE REINITIALISES SURFACE RUNOFF AT THE END OF
        ! EVERY YEAR

        ! DESCRIPTION OF VARIABLES:

        ! ROWS,COLS: ROWS AND COLUMNS OF THE STUDY AREA. REMAINS
        ! UNMODIFIED IN THIS SUBROUTINE
        
        ! CMARK: SHOWS 1 FOR CREVASSED CELL AND 0 FOR NON CREVASSED CELL.
        ! UPDATED EVERY TIMESTEP IN THE CREV_CELLS1.F SUBROUTINE. GETS
        ! UNMODIFIED IN THIS SUBROUTINE

        ! RUNOFF: CONTAINS RUNOFF MELTWATER (IN METERS) FOR EVERY GRID
        ! CELL. GETS MODIFIED IN THIS SUBROUTINE

        ! CREV_DEP: CONTAINS CREVASSE DEPTH FOR EVERY GRID CELL.
        ! GETS MODIFIED IN THIS SUBROUTINE

        ! WAT_DEP: SHOWS DEPTH OF WATER (IN METERS) IN CREVASSED CELLS. FOR
        ! NON-CREVASSED CELLS, THE VALUE IS 0. GETS MODIFIED IN THIS
        ! SUBROUTINE

        ! ICE: CONTAINS ICE THICKNESS (IN METERS) FOR EVERY GRID CELL.
        ! REMAINS UNMODIFIED IN THIS SUBROUTINE


        IMPLICIT NONE

        INTEGER :: ROWS,COLS,I,J,C_MARK(COLS,ROWS)
        DOUBLE PRECISION :: CREV_DEP(COLS,ROWS),WAT_DEP(COLS,ROWS),
     &ICE(COLS,ROWS),RUNOFF(COLS,ROWS)

        DO 100 I=1,COLS
        DO 200 J=1,ROWS
        IF (RUNOFF(I,J).EQ.0) THEN
                CREV_DEP(I,J)=0
                C_MARK(I,J)=0
                WAT_DEP(I,J)=0
        END IF
200     CONTINUE
100     CONTINUE
 
        RETURN
        END SUBROUTINE REINIT1
